import json
import os
import requests
from bs4 import BeautifulSoup

SEARCH_URL = "https://warosu.org/vt/?task=search2&ghost=&search_text=rabbalabs&search_subject=&search_username=&search_tripcode=&search_email=&search_filename=&search_datefrom=&search_dateto=&search_op=op&search_del=dontcare&search_int=dontcare&search_ord=new&search_capcode=all&search_res=post"
SAVE_FILE = "/disk1/pyondex/new_threads.json"
START_OFFSET = 0
END_OFFSET = 0
MAX_LIST_SIZE = 20

verbose_output = False


def main():
    offset = START_OFFSET
    threads = set()
    if os.path.isfile(SAVE_FILE):
        with open(SAVE_FILE) as prev_threads:
            threads = set(json.load(prev_threads))
    print("Checking for new threads.")
    while True:
        if verbose_output:
            print(f"Getting threads {offset + 1} - {offset + 24}")
        archive_html = requests.get(f"{SEARCH_URL}&offset={offset}")
        soup = BeautifulSoup(archive_html.content, "html.parser")
        links = soup.findAll("a", href=True, text="View")
        if len(links) == 0:
            break
        for link in links:
            threads.add(link["href"].partition("#")[0])
        offset += 24
        if END_OFFSET is not None and offset > END_OFFSET:
            break
    if threads:
        with open(SAVE_FILE, "w") as out_file:
            json.dump(
                sorted(
                    list(threads), reverse=True, key=lambda i: int(i.rpartition("S")[2])
                )[:MAX_LIST_SIZE],
                out_file,
            )


if __name__ == "__main__":
    verbose_output = True
    main()
